#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin>>n>>q;
    vector<int> a(n), pref_br_u(n+1);
    pref_br_u[0]=0;
    for(int i=0;i<n;i++)
    {
        char c;
        cin>>c;
        if(c=='?')
        {
            a[i]=5;
            pref_br_u[i+1]=pref_br_u[i]+1;
        }
        else
        {
            a[i]=c-'0';
            pref_br_u[i+1]=pref_br_u[i];
        }
    }
    for(int i=0;i<q;i++)
    {
        int l, r, m=0;
        cin>>l>>r;
        l--;
        for(int j=pref_br_u[l+1];j<=pref_br_u[r];j++)
        {
            int s=0, p=0;
            for(int k=l;k<r;k++)
                if(a[k]==6 || (a[k]==5 && pref_br_u[k+1]<j))
                    p++;
                else if(a[k]==7 || (a[k]==5 && pref_br_u[k+1]>=j))
                    s+=p;
            m=max(m,s);
        }
        cout<<m<<'\n';
    }
    return 0;
}